module Sexp
  
  def type
    self[0]
  end
  
  def perform_process_call(target_class)
    exp = self[1..-1]
    exp.extend Clonable
    target_class.send("process_#{type}", exp)
  end

end

# Should not be used, for compatibility only.
module Clonable
  def deep_clone
    Marshal.load(Marshal.dump(self))
  end
end